Série por caminho

From FreeCAD Documentation
This page is a translated version of the page Draft PathArray and the translation is 13% complete.
Outdated translations are marked like this.

Draft PathArray

Menu location
Modification → Array tools → Path array
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.14
See also
Draft OrthoArray, Draft PolarArray, Draft CircularArray, Draft PathLinkArray, Draft PointArray, Draft PointLinkArray

Descrição

The Draft PathArray command creates a regular array from a selected object by placing copies along a path. Use the Draft PathLinkArray command to create a more efficient Link array instead. Except for the type of array that is created, Link array or regular array, the Draft PathLinkArray command is identical to this command.

Both commands can be used on 2D objects created with the Draft Workbench or Sketcher Workbench, but also on many 3D objects such as those created with the Part Workbench, PartDesign Workbench or Arch Workbench.

Draft PathArray

Utilização

  1. Select the object you wish to array.
  2. Add the path object to the selection. It is also possible to select edges instead. The edges must belong to the same object and they must be connected.
  3. There are several ways to invoke the command:
    • Press the Path array button.
    • Select the Modification → Array tools → Path array option from the menu.
  4. The array is created.
  5. Optionally change the properties of the array in the Property editor.

Alignment

The alignment of the elements in a Draft PathArray depends on the properties of the array and the orientation of the source object. The position of the source object is ignored: for the purpose of the array the x, y and z are set to 0. If the DadosAlign property of the array is set to false the orientation of the array elements is identical to that of the source object. If it is set to true the X axis of the local coordinate system of each element placement is tangent to the path. The Y and Z axes of the local coordinate systems depend on the DadosAlign Mode property of the array. Other array properties involved in the alignment include DadosTangent Vector, DadosForce Vertical and DadosVertical Vector.

3 arrays based on the same non-planar path. From left to right: Align is false, Align is true with Align Mode Original and Align is true with Align Mode Frenet

.

Align Mode

Three modes are available:

Original

This mode comes closest to the single DadosAlign Mode available in version 0.18. It relies on a fixed normal vector. If the path is planar this vector is perpendicular to the plane of the path, else a default vector, the positive Z axis, is used. From this normal vector and the local tangent vector (the local X axis) a cross product is calculated. This new vector is used as the local Z axis. The orientation of the local Y axis is determined from the local X and Z axes.

Frenet

This mode uses the local normal vector derived from the path at each element placement. If this vector cannot be determined (for example in the case of a straight segment) a default vector, again the positive Z axis, is used instead. With this vector and the local tangent vector the local coordinate system is determined using the same procedure as in the previous paragraph.

Tangent

This mode is similar to DadosAlign Mode Original but includes the possibility to pre-rotate the source object by specifying a DadosTangent Vector.

Force Vertical and Vertical Vector

These properties are only available if DadosAlign Mode is Original or Tangent. If DadosForce Vertical is set to true the local coordinate system is calculated in a different manner. The DadosVertical Vector is used as a fixed normal vector. From this normal vector and the local tangent vector (the local X axis) again a cross product is calculated. But now this vector is used as the local Y axis. The orientation of the local Z axis is determined from the local X and Y axes.

Using these properties can be required if one of the edged of the path is (almost) parallel to the default normal of the path.

Propriedades

See also: Property editor.

A Draft PathArray object is derived from a Part Feature object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:

Data

Link

The properties in this group are only available for Link arrays. See Std LinkMake for more information.

  • DadosScale (Float)
  • Dados (Hidden)Scale Vector (Vector)
  • DadosScale List (VectorList)
  • Dados (Hidden)Visibility List (BoolList)
  • Dados (Hidden)Placement List (PlacementList)
  • Dados (Hidden)Element List (LinkList)
  • Dados (Hidden)_ Link Touched (Bool)
  • Dados (Hidden)_ Child Cache (LinkList)
  • Dados (Hidden)Colored Elements (LinkSubHidden)
  • DadosLink Transform (Bool)

Alignment

  • DadosAlign (Bool): specifies if the elements in the array are aligned along the path or not. If it is false all other properties in this group, except DadosExtra Translation, do not apply and are hidden.
  • DadosAlign Mode (Enumeration): specifies the align mode, which can be Original, Frenet or Tangent.
  • DadosEnd Offset (Length): specifies the length from the end of the path to the last copy. Must be smaller than the length of the path minus the DadosStart Offset. introduced in version 0.21
  • DadosExtra Translation (VectorDistance): specifies an additional displacement for each element along the path.
  • DadosForce Vertical (Bool): specifies whether to override the default normal direction with the value of DadosVertical Vector. Only used if DadosAlign Mode is Original or Tangent.
  • DadosStart Offset (Length): specifies the length from the start of the path to the first copy. Must be smaller than the length of the path. introduced in version 0.21
  • DadosTangent Vector (Vector): specifies the alignment vector. Only used if DadosAlign Mode is Tangent.
  • DadosVertical Vector (Vector): specifies the override for the default normal direction. Only used if DadosVertical Vector is true.

Objects

  • DadosBase (LinkGlobal): specifies the object to duplicate in the array.
  • DadosCount (Integer): specifies the number of elements in the array.
  • DadosExpand Array (Bool): specifies whether to expand the array in the Tree view to enable the selection of its individual elements. Only available for Link arrays.
  • DadosPath Object (LinkGlobal): specifies the object to be used for the path. It must contain Edges in its Part TopoShape.
  • DadosPath Subelements (LinkSubListGlobal): specifies a list of edges of the DadosPath Object. If supplied only these edges are used for the path.

Vista

Link

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • VistaDraw Style (Enumeration)
  • VistaLine Width (FloatConstraint)
  • VistaOverride Material (Bool)
  • VistaPoint Size (FloatConstraint)
  • VistaSelectable (Bool): this is an inherited property that appears in the Selection group for other arrays
  • VistaShape Material (Material)

Base

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • Vista (Hidden)Child View Provider (PersistentObject)
  • Vista (Hidden)Material List (MaterialList)
  • Vista (Hidden)Override Color List (ColorList)
  • Vista (Hidden)Override Material List (BoolList)
  • Vista (Hidden)Proxy (PythonObject): this is an inherited property.

Display Options

The properties in this group are inherited properties. See Part Feature for more information.

  • VistaBounding Box (Bool): this property is not inherited by Link arrays.
  • VistaDisplay Mode (Enumeration): for Link arrays it can be Link or ChildView. For other arrays it can be: Flat Lines, Shaded, Wireframe or Points
  • VistaShow In Tree (Bool)
  • VistaVisibility (Bool)

Draft

  • VistaPattern (Enumeration): not used.
  • VistaPattern Size (Float): not used.

Object style

The properties in this group are not inherited by Link arrays.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a path array use the make_path_array method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makePathArray method.

path_array = make_path_array(base_object, path_object,
                             count=4, extra=App.Vector(0, 0, 0), subelements=None,
                             align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
                             force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
                             use_link=True)
  • base_object is the object to be arrayed. It can also be the Label (string) of an object in the current document.
  • path_object is the path object. It can also be the Label (string) of an object in the current document.
  • count is the number of elements in the array.
  • extra is a vector that displaces each element.
  • subelements is a list of edges of path_object, for example ["Edge1", "Edge2"]. If supplied only these edges are used for the path.
  • If align is True the elements are aligned along the path depending on the value of align_mode, which can be "Original", "Frenet" or "Tangent".
  • tan_vector is a unit vector that defines the local tangent direction of the elements along the path. It is used when align_mode is "Tangent".
  • If force_vertical is True vertical_vector is used for the local Z direction of the elements along the path. It is used when align_mode is "Original" or "Tangent".
  • If use_link is True the created elements are App Links instead of regular copies.
  • path_array is returned with the created array object.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(500, -1000, 0)
p2 = App.Vector(1500, 1000, 0)
p3 = App.Vector(3000, 500, 0)
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)

path_array = Draft.make_path_array(obj, spline, 6)
doc.recompute()

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()